1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 msgpass
() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
47 if [ $MSGLEVEL -le 3 ]; then
51 if [ $MSGLEVEL -le 4 ]; then
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
63 echo "${CDONE}DONE${CNORMAL}" >&2;
68 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
69 if [ -f .
/aptconfig.conf
]; then
70 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
71 elif [ -f ..
/aptconfig.conf
]; then
72 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
74 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
77 aptconfig
() { runapt apt
-config $
*; }
78 aptcache
() { runapt apt
-cache $
*; }
79 aptget
() { runapt apt
-get $
*; }
80 aptftparchive
() { runapt apt
-ftparchive $
*; }
81 aptkey
() { runapt apt
-key $
*; }
82 aptmark
() { runapt apt
-mark $
*; }
84 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
87 if [ -f .
/aptconfig.conf
]; then
88 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
89 elif [ -f ..
/aptconfig.conf
]; then
90 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
92 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
97 CURRENTTRAP
="$CURRENTTRAP $1"
98 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
102 TMPWORKINGDIRECTORY
=$(mktemp -d)
103 local TESTDIR
=$(readlink -f $(dirname $0))
104 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
105 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
106 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
107 local OLDWORKINGDIRECTORY
=$(pwd)
108 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
109 cd $TMPWORKINGDIRECTORY
110 mkdir rootdir aptarchive keys
112 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
113 mkdir -p var
/cache var
/lib var
/log
114 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
115 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
116 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
117 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
119 touch var/lib/dpkg/status
121 touch var/lib/dpkg/available
123 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
125 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
126 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
127 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
129 local SOURCESSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
130 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
131 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
133 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
134 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
135 echo "Dir
\"${TMPWORKINGDIRECTORY}/rootdir
\";" > aptconfig.conf
136 echo "Dir
::state
::status
\"${TMPWORKINGDIRECTORY}/rootdir
/var
/lib
/dpkg
/status
\";" >> aptconfig.conf
137 echo "Debug
::NoLocking
\"true
\";" >> aptconfig.conf
138 echo "APT
::Get
::Show
-User-Simulation-Note \"false
\";" >> aptconfig.conf
139 echo "Dir
::Bin
::Methods
\"${BUILDDIRECTORY}/methods
\";" >> aptconfig.conf
140 echo "Dir
::Bin
::dpkg
\"fakeroot
\";" >> aptconfig.conf
141 echo "DPKG
::options
:: \"dpkg
\";" >> aptconfig.conf
142 echo "DPKG
::options
:: \"--root=${TMPWORKINGDIRECTORY}/rootdir
\";" >> aptconfig.conf
143 echo "DPKG
::options
:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG
::options
:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG
::options
:: \"--log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log
\";" >> aptconfig.conf
146 echo 'quiet::NoUpdate "true
";' >> aptconfig.conf
151 configarchitecture() {
152 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
153 echo "APT
::Architecture
\"$1\";" > $CONFFILE
155 while [ -n "$1" ]; do
156 echo "APT
::Architectures
:: \"$1\";" >> $CONFFILE
161 setupsimplenativepackage() {
165 local RELEASE="${4:-unstable}"
166 local DEPENDENCIES="$5"
167 local DESCRIPTION="$6"
168 local SECTION="${7:-others}"
170 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
173 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
175 local BUILDDIR=incoming/${NAME}-${VERSION}
176 mkdir -p ${BUILDDIR}/debian/source
178 echo "* most suckless software product ever
" > FEATURES
179 test -e debian/copyright || echo "Copyleft by Joe Sixpack
$(date +%Y)" > debian/copyright
180 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency
=low
184 -- Joe Sixpack
<joe@example.org
> $(date -R)" > debian/changelog
185 test -e debian/control || echo "Source
: $NAME
188 Maintainer
: Joe Sixpack
<joe@example.org
>
189 Build
-Depends: debhelper
(>= 7)
190 Standards
-Version: 3.9.1
192 Package
: $NAME" > debian/control
193 if [ "$ARCH" = 'all' ]; then
194 echo "Architecture
: all
" >> debian/control
196 echo "Architecture
: any
" >> debian/control
198 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
199 if [ -z "$DESCRIPTION" ]; then
200 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
201 If you
find such a package installed on your system
,
202 YOU did something horribly wrong
! They are autogenerated
203 und used only by testcases
for APT and surf no other propose…
" >> debian/control
205 echo "Description
: $DESCRIPTION" >> debian/control
207 test -e debian/compat || echo "7" > debian/compat
208 test -e debian/source/format || echo "3.0 (native
)" > debian/source/format
209 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
213 buildsimplenativepackage() {
217 local RELEASE="${4:-unstable}"
218 local DEPENDENCIES="$5"
219 local DESCRIPTION="$6"
220 local SECTION="${7:-others}"
222 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
225 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
227 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
229 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
230 mkdir -p $BUILDDIR/debian/source
231 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
233 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
235 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
236 echo "$NAME ($VERSION) $RELEASE; urgency
=low
240 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
244 Maintainer
: Joe Sixpack
<joe@example.org
>
245 Standards
-Version: 3.9.1
247 Package
: $NAME" > ${BUILDDIR}/debian/control
248 if [ "$ARCH" = 'all' ]; then
249 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
251 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
253 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
254 if [ -z "$DESCRIPTION" ]; then
255 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
256 If you
find such a package installed on your system
,
257 YOU did something horribly wrong
! They are autogenerated
258 und used only by testcases
for APT and surf no other propose…
" >> ${BUILDDIR}/debian/control
260 echo "Description
: $DESCRIPTION" >> ${BUILDIR}/debian/control
262 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
263 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
265 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
268 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
269 rm -rf ${BUILDDIR}/debian/tmp
270 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
271 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
272 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
273 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
274 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
276 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
277 echo "pool
/${NAME}_
${VERSION}_
${arch}.deb
" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
280 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
281 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
282 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
291 msgninfo "Build package
$(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}…
"
293 if [ "$ARCH" = "all
" ]; then
294 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
296 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
297 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
298 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
301 echo "pool
/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
304 echo "pool
/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
310 if [ -d incoming ]; then
311 buildaptarchivefromincoming $*
313 buildaptarchivefromfiles $*
317 createaptftparchiveconfig() {
318 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb
$#\
1#' | tr '\n' ' ')"
319 if [ -z "$ARCHS" ]; then
320 # the pool is empty, so we will operate on faked packages - let us use the configured archs
321 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
324 ArchiveDir "' >> ftparchive.conf
325 echo -n $(readlink -f .) >> ftparchive.conf
327 CacheDir "' >> ftparchive.conf
328 echo -n $(readlink -f ..) >> ftparchive.conf
330 FileListDir "' >> ftparchive.conf
331 echo -n $(readlink -f pool/) >> ftparchive.conf
335 Packages::Compress ". gzip bzip2 lzma xz";
336 Sources::Compress ". gzip bzip2 lzma xz";
337 Contents::Compress ". gzip bzip2 lzma xz";
338 Translation::Compress ". gzip bzip2 lzma xz";
339 LongDescription "false";
343 SrcDirectory "pool/";
349 Label "apttestcases";
351 Description "repository with dummy packages";
352 Architectures "' >> ftparchive.conf
353 echo -n "$ARCHS" >> ftparchive.conf
357 };' >> ftparchive.conf
358 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
359 echo -n 'tree "dists/' >> ftparchive.conf
360 echo -n "$DIST" >> ftparchive.conf
362 Architectures "' >> ftparchive.conf
363 echo -n "$ARCHS" >> ftparchive.conf
365 FileList "' >> ftparchive.conf
366 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
368 SourceFileList "' >> ftparchive.conf
369 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
371 Sections "' >> ftparchive.conf
372 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
374 };' >> ftparchive.conf
378 buildaptftparchivedirectorystructure
() {
379 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
380 for DIST
in $DISTS; do
381 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
382 for SECTION
in $SECTIONS; do
383 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
384 for ARCH
in $ARCHS; do
385 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
387 mkdir -p dists
/${DIST}/${SECTION}/source
388 mkdir -p dists
/${DIST}/${SECTION}/i18n
398 local DEPENDENCIES
="$5"
400 if [ "$ARCHS" = "all" ]; then
401 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
403 for BUILDARCH
in $ARCHS; do
404 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
405 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
406 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
407 local FILE
="${PPATH}/Packages"
412 Maintainer: Joe Sixpack <joe@example.org>
415 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
416 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
417 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
418 If you find such a package installed on your system,
419 YOU did something horribly wrong! They are autogenerated
420 und used only by testcases for APT and surf no other propose…
425 insertinstalledpackage
() {
429 local DEPENDENCIES
="$4"
430 local FILE
="rootdir/var/lib/dpkg/status"
432 Status: install ok installed
436 Maintainer: Joe Sixpack <joe@example.org>
438 Version: $VERSION" >> $FILE
439 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
440 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
441 If you find such a package installed on your system,
442 YOU did something horribly wrong! They are autogenerated
443 und used only by testcases for APT and surf no other propose…
448 buildaptarchivefromincoming
() {
449 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
451 [ -e pool
] || ln -s ..
/incoming pool
452 [ -e ftparchive.conf
] || createaptftparchiveconfig
453 [ -e dists
] || buildaptftparchivedirectorystructure
454 msgninfo
"\tGenerate Packages, Sources and Contents files… "
455 aptftparchive
-qq generate ftparchive.conf
461 buildaptarchivefromfiles
() {
462 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
463 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
464 msgninfo
"\t${line} file… "
465 cat ${line} | gzip > ${line}.gz
466 cat ${line} | bzip2 > ${line}.bz2
467 cat ${line} | lzma
> ${line}.lzma
468 cat ${line} | xz
> ${line}.xz
474 generatereleasefiles
() {
475 msgninfo
"\tGenerate Release files… "
476 local DATE
="${1:-now}"
477 if [ -e aptarchive
/dists
]; then
478 for dir
in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
479 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Patterns
::='Translation-*' > $dir/Index
481 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
482 local CODENAME
="$(echo "$dir" | cut -d'/' -f 4)"
483 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Suite
="${CODENAME}" -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
484 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
486 NotAutomatic: yes' $dir/Release
490 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
492 if [ "$DATE" != "now" ]; then
493 for release
in $(find ./aptarchive -name 'Release'); do
494 touch -d "$1" $release
500 setupdistsaptarchive
() {
501 local APTARCHIVE
=$(readlink -f ./aptarchive)
502 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
503 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
504 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
505 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
506 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
507 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
508 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
513 setupflataptarchive
() {
514 local APTARCHIVE
=$(readlink -f ./aptarchive)
515 if [ -f ${APTARCHIVE}/Packages
]; then
516 msgninfo
"\tadd deb sources.list line… "
517 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
520 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
522 if [ -f ${APTARCHIVE}/Sources
]; then
523 msgninfo
"\tadd deb-src sources.list line… "
524 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
527 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
533 if [ -e aptarchive
/dists
]; then
539 msgninfo
"\tSync APT's cache with the archive… "
545 local SIGNER
="${1:-Joe Sixpack}"
546 msgninfo
"\tSign archive with $SIGNER key… "
548 for KEY
in $(find keys/ -name '*.sec'); do
549 SECKEYS
="$SECKEYS --secret-keyring $KEY"
552 for KEY
in $(find keys/ -name '*.pub'); do
553 PUBKEYS
="$PUBKEYS --keyring $KEY"
555 for RELEASE
in $(find aptarchive/ -name Release); do
556 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
557 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
562 changetowebserver
() {
563 if which weborf
> /dev
/null
; then
564 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
566 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
567 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
568 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
576 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
577 if [ -n "$DIFFTEXT" ]; then
589 msgtest
"Test for correctness of file" "$FILE"
591 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
593 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
598 local COMPAREFILE
=$(mktemp)
599 addtrap
"rm $COMPAREFILE;"
600 echo "$1" > $COMPAREFILE
602 msgtest
"Test for equality of" "$*"
603 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
607 local COMPAREFILE1
=$(mktemp)
608 local COMPAREFILE2
=$(mktemp)
609 local COMPAREAGAINST
=$(mktemp)
610 addtrap
"rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
611 echo "$1" > $COMPAREFILE1
612 echo "$2" > $COMPAREFILE2
614 msgtest
"Test for equality OR of" "$*"
615 $
* 2>&1 1> $COMPAREAGAINST
616 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
617 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
618 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
619 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
624 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
627 while [ -n "$1" ]; do
629 N: Can't select versions from package '$1' as it is purely virtual"
630 PACKAGE
="${PACKAGE} $1"
633 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
635 N: No packages found"
636 local COMPAREFILE
=$(mktemp)
637 addtrap
"rm $COMPAREFILE;"
638 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
639 eval `apt-config shell ARCH APT::Architecture`
640 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
641 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
645 msgtest
"Test for non-existent packages" "apt-cache show $*"
646 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
647 if [ -n "$SHOWPKG" ]; then
656 testdpkginstalled
() {
657 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
658 local PKGS
="$(dpkg -l $* | grep '^i' | wc -l)"
659 if [ "$PKGS" != $# ]; then
661 dpkg
-l $
* | grep '^[a-z]'
668 testdpkgnotinstalled
() {
669 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
670 local PKGS
="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
671 if [ "$PKGS" != 0 ]; then
673 dpkg
-l $
* | grep '^[a-z]'
681 local COMPAREFILE
=$(mktemp)
682 addtrap
"rm $COMPAREFILE;"
684 msgtest
'Test for correctly marked as auto-installed' "$*"
685 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
687 msgtest
'Test for correctly marked as auto-installed' 'no package'
690 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail